VERSION 5.00
Begin VB.Form frmEdit 
   Caption         =   "Form2"
   ClientHeight    =   8715
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7725
   LinkTopic       =   "Form2"
   ScaleHeight     =   8715
   ScaleWidth      =   7725
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Write Output File"
      Height          =   375
      Left            =   5040
      TabIndex        =   4
      Top             =   600
      Width           =   2055
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Resize"
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   600
      Width           =   735
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1920
      TabIndex        =   2
      Text            =   "Text1"
      Top             =   600
      Width           =   495
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   6375
      Left            =   840
      ScaleHeight     =   6315
      ScaleWidth      =   6075
      TabIndex        =   1
      Top             =   1560
      Width           =   6135
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   360
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   600
      Width           =   975
   End
End
Attribute VB_Name = "frmEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
DefInt A-Z

' Data file format
' ~~~~~~~~~~~~~~~~
' line 1    = name charset prefix
' line 2    = height = (bytes) 1-3
' line 3... = char, width, bitmap (chars 0x21 to MAX_CHAR)
'                 char   = char letter
'                 width  = pixels
'                 bitmap = byte1, byte2, byte3
'
' Output file format
' ~~~~~~~~~~~~~~~~~~
'
' PREFIX_BITMAP
'   db  byte!a, byte!b, ...
' PREFIX_SIZES
'   db  size1, size2, ...
' PREFIX_INDEX
'   dw  offset1     ; offset relative to PREFIX_BITMAP label
'   dw  offset2
'   ...

Const CHARSET_FILENAME = "font16.dat"
Const CHARSET_OUTFILE = "font16.inc"
Const MAX_WIDTH = 16
Const MAX_CHAR = &H81 '&H5A ' "Z"
Const CHARSET_EXCLUDE = "" 'not written to output even if exists in charset

Dim CHARSET$(&H21 To MAX_CHAR) 'CSV
Dim CHARSET_PREFIX$
Dim CHARSET_HEIGHT$

Dim charBytes
Dim charHgt
Dim charWid
Dim cellHgt
Dim cellWid
Dim gDirty As Boolean

Private Sub Form_Load()
    
 
 GoTo SKIPTHIS
 Open "old.dat" For Input As #1
 Open CHARSET_FILENAME For Output As #2
    Print #2, "CHARSET_16"
    Print #2, "2"
        Dim z: For z = &H21 To MAX_CHAR
        Line Input #1, CHARSET$(z)
        Print #2, Chr$(z) & " ";
        Dim w: w = Len(CHARSET$(z)) / 4
        Dim j: For j = 0 To w - 1
            Dim b As Long
            b = Val("&h" & Mid$(CHARSET$(z), j * 4 + 3, 2))
            Dim bb As Long
            Dim r
            bb = 0: For r = 1 To 8: bb = bb * 2 + IIf((b And 1) = 0, 0, 1): b = b \ 2: Next r
            Print #2, Right$("00" & Hex$(bb), 2);
            b = Val("&h" & Mid$(CHARSET$(z), j * 4 + 1, 2))
            bb = 0: For r = 1 To 8: bb = bb * 2 + IIf((b And 1) = 0, 0, 1): b = b \ 2: Next r
            Print #2, Right$("00" & Hex$(bb), 2);
'            Print #2, "00";
        Next j
        Print #2,
    Next z
 Close #2
 Close #1
 Stop
SKIPTHIS:

    Dim i: For i = &H21 To MAX_CHAR
        Combo1.AddItem Hex$(i) & " (" & Chr$(i) & ")"
    Next i
    
    loadCharset CHARSET_FILENAME
    
    charBytes = Val(CHARSET_HEIGHT$)
    charHgt = charBytes * 8
    charWid = MAX_WIDTH 'allows for graphics pseudo-characters to be created
    
    cellHgt = Picture1.ScaleHeight / charHgt
    cellWid = Picture1.ScaleWidth / charWid
    
    Combo1.ListIndex = &H41 - &H21
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  If gDirty Then
    Select Case MsgBox("Save changes?", vbYesNoCancel, "Charset Editor")
        Case vbCancel: Cancel = True: Exit Sub
        Case vbYes: doSave
    End Select
  End If
End Sub


Sub loadCharset(ByVal zFile$)
    Open zFile$ For Input As #1
        Line Input #1, CHARSET_PREFIX$
        Line Input #1, CHARSET_HEIGHT$
        Dim i: For i = &H21 To MAX_CHAR
            Line Input #1, CHARSET$(i)
        Next i
    Close #1

    gDirty = False
End Sub

Sub doSave()
    Open CHARSET_FILENAME For Output As #1
        Print #1, CHARSET_PREFIX$
        Print #1, CHARSET_HEIGHT$
        Dim i: For i = &H21 To MAX_CHAR
            Print #1, CHARSET$(i)
        Next i
    Close #1
End Sub


Private Function HexToBin(ByVal zBytes, ByVal zHex$) As String
    Dim result$: result$ = ""
    Dim i: For i = zBytes To 1 Step -1
        Dim b As Long: b = Val("&h" & Mid$(zHex$, i * 2 - 1, 2))
        Dim j: For j = 1 To 8
            result$ = IIf((b And 1) = 0, "0", "1") & result$
            b = b \ 2
        Next j
    Next i
    HexToBin = result$
End Function


Private Sub Combo1_Click()
    
    Picture1.Cls
    
    Dim ch$: ch$ = Mid$(CHARSET$(Combo1.ListIndex + &H21), 3) 'clip char description
    
    Dim w: w = Len(ch$) / (2 * charBytes)

    Text1.Text = Format$(w)
    
    Dim i, j
    For i = 0 To w - 1
        Dim b$: b$ = HexToBin(charBytes, Mid$(ch$, i * 2 * charBytes + 1))
        For j = 0 To charHgt - 1
            Dim c As Long: c = IIf(Mid$(b$, j + 1, 1) = "0", 0, &HFFFFFF)
            Picture1.Line (cellWid * i + Screen.TwipsPerPixelX, cellHgt * j + Screen.TwipsPerPixelY)-Step(cellWid - 2 * Screen.TwipsPerPixelX, cellHgt - 2 * Screen.TwipsPerPixelY), c, BF
        Next j
    Next i
    
    For i = 1 To charWid - 1
        Picture1.Line (i * cellWid, 0)-(i * cellWid, Picture1.ScaleHeight), &H7F7F7F
    Next i
    For i = 1 To charHgt - 1
        Picture1.Line (i, i * cellHgt)-(Picture1.ScaleWidth, i * cellHgt), &H7F7F7F
    Next i
    
    Picture1.Line (0, 0)-Step(cellWid * w, charHgt * cellHgt - 1 * Screen.TwipsPerPixelY), &HFF, B
    
End Sub


Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
 
    Dim cellX: cellX = X \ cellWid
    Dim cellY: cellY = Y \ cellHgt
'Debug.Print cellX, cellY

    Dim ch$: ch$ = Mid$(CHARSET$(Combo1.ListIndex + &H21), 3) 'clip char description

    If cellX * charBytes * 2 + 1 > Len(ch$) Then Beep: Exit Sub

    'update bit
'Debug.Print ch$
    Dim byt: byt = cellY \ 8
    Dim bit: bit = cellY Mod 8
        bit = 7 - bit
'Debug.Print byt, bit
    Dim c As Long: c = Val("&h" & Mid$(ch$, cellX * charBytes * 2 + byt * 2 + 1, 2) & "&")
        c = c Xor (2 ^ bit)
        Mid$(ch$, cellX * charBytes * 2 + byt * 2 + 1, 2) = hex2(c)
     
    'update charset
    CHARSET$(Combo1.ListIndex + &H21) = Chr$(Combo1.ListIndex + &H21) & " " & ch$
'Debug.Print ch$

    'update display
    c = IIf((c And (2 ^ bit)) = 0, 0, &HFFFFFF)
    Picture1.Line (cellWid * cellX + Screen.TwipsPerPixelX, cellHgt * cellY + Screen.TwipsPerPixelY)-Step(cellWid - 2 * Screen.TwipsPerPixelX, cellHgt - 2 * Screen.TwipsPerPixelY), c, BF
 
    gDirty = True

End Sub


Private Sub Command1_Click() 'resize (number of columns)

    Dim w: w = Val(Text1.Text)
    
    If w > MAX_WIDTH Then MsgBox "I don't think so.": Exit Sub
    
    CHARSET$(Combo1.ListIndex + &H21) = Left$(CHARSET$(Combo1.ListIndex + &H21) & String(w * charBytes * 2, "0"), 2 + w * charBytes * 2)

    Combo1_Click

    gDirty = True

End Sub


Private Function hex2(ByVal zInput As Variant) As String
    hex2 = Right$("0" & Hex$(zInput), 2)
End Function

Private Function hex4(ByVal zInput As Long) As String
    Dim h As Long: h = zInput \ 256
    Dim l As Long: l = zInput And &HFF
    hex4 = hex2(h) & hex2(l)
End Function


Private Sub Command2_Click() 'write output file

    Open CHARSET_OUTFILE For Output As #1
    
        Print #1, "; " & CHARSET_OUTFILE
        Print #1,

        Dim OFFSETS(&H21 To MAX_CHAR) As Long
        Dim offset As Long
            offset = (MAX_CHAR - &H21 + 1) * 2 'bitmap immediately follows index table
        
'-- emit bitmap section
        
        'pack 20(max) bytes per source line (~100 chars)
        '  byte count must be even or the assembler will pad to word boundary!
        
        Dim db_buff$(1 To 40)
        Dim db_count: db_count = 0
        
        Dim BitBuff$
            BitBuff$ = "; character bitmaps" & vbCrLf
            
        Dim i: For i = &H21 To MAX_CHAR
             
            If InStr(CHARSET_EXCLUDE, Chr$(i)) > 0 Then
                OFFSETS(i) = 0 'dummy value
            Else
                Dim ch$: ch$ = Mid$(CHARSET$(i), 3) 'clip char description
                Dim w: w = Len(ch$) / (charBytes * 2)
                
                'reverse bit direction to match LCD convention (it's upside down)
                Dim X: For X = 0 To w - 1
                    Dim temp$: temp$ = ""
                    Dim Y: For Y = 0 To charBytes - 1
                        Dim b As Long: b = Val("&h" & Mid$(ch$, X * charBytes * 2 + Y * 2 + 1, 2))
                        Dim bb As Long: bb = 0: Dim r: For r = 1 To 8: bb = bb * 2 + IIf((b And 1) = 0, 0, 1): b = b \ 2: Next r
                        temp$ = hex2(bb) & temp$
                    Next Y
                    Mid$(ch$, X * charBytes * 2 + 1, charBytes * 2) = temp$
                Next X
                            
                For X = 1 To Len(ch$) Step 2
                    db_count = db_count + 1
                    db_buff$(db_count) = "0x" & Mid$(ch$, X, 2)
                    ' emit full block
                    If db_count = 20 Then
                        BitBuff$ = BitBuff$ & " db "
                        Dim j, sep$: sep$ = ""
                        For j = 1 To 20: BitBuff$ = BitBuff$ & sep$ & db_buff$(j): sep$ = ",": Next j
                        BitBuff$ = BitBuff$ & vbCrLf
                        db_count = 0
                    End If
                Next X
            
                OFFSETS(i) = offset
                offset = offset + Len(ch$) / 2
            End If
            
        Next i
        
        If db_count > 0 Then 'emit partial block
                    BitBuff$ = BitBuff$ & " db "
                    sep$ = ""
                    For j = 1 To db_count: BitBuff$ = BitBuff$ & sep$ & db_buff$(j): sep$ = ",": Next j
                    BitBuff$ = BitBuff$ & vbCrLf
        End If
        
'-- emit sizes section
            
        Print #1, CHARSET_PREFIX$ & "_SIZES   ; char widths"
            
        db_count = 0
            
        For i = &H21 To MAX_CHAR
             
            ch$ = Mid$(CHARSET$(i), 3) 'clip char description
            
            If InStr(CHARSET_EXCLUDE, Chr$(i)) > 0 Then
                w = 0 'suppress char in output
            Else
                w = Len(ch$) / (charBytes * 2)
            End If
            
            db_count = db_count + 1
            db_buff$(db_count) = Format$(w)
            ' emit full block
            If db_count = 40 Then
                Print #1, " db ";
                sep$ = ""
                For j = 1 To 40: Print #1, sep$ & db_buff$(j);: sep$ = ",": Next j
                Print #1,
                db_count = 0
            End If
            
        Next i
        
        If db_count > 0 Then 'emit partial block
                Print #1, " db ";
                sep$ = ""
                For j = 1 To db_count: Print #1, sep$ & db_buff$(j);: sep$ = ",": Next j
                Print #1,
        End If
        Print #1,
            
'-- emit charset section
            
        Print #1, CHARSET_PREFIX$ & "_INDEX ; char bitmap locations, contiguous for chars 0x21..0x" & Hex$(MAX_CHAR)
            
        For i = &H21 To MAX_CHAR
            Print #1, " dw 0x" & hex4(OFFSETS(i)) & " ; " & Chr$(i)
        Next i
    
        Print #1, BitBuff$;
    
    Close #1
End Sub

