;**********************************************************************************************
;   00617 - Math Routines
;   FXM.A17, FXDB.A17
;	$Revision: 2.4 $
;   PIC17 FIXED POINT DIVIDE ROUTINES A
;   Adapted for PIC18 2010/10/20 RSP
;**********************************************************************************************

#define LSB B0

UDIV3123        macro

                variable i

                MOVFF           BARGB2,WREG
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                RLCF            AARGB0,F,    BANKED

                RLCF            AARGB0,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED
                RLCF            AARGB0,F,    BANKED

                variable i = D'2'

                while i < D'8'

                RLCF            AARGB0,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                BTFSS           AARGB0,LSB,  BANKED
                bra             UADD13#v(i)
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                bra             UOK13#v(i)

UADD13#v(i)     ADDWF           REMB2, F
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F

UOK13#v(i)      RLCF            AARGB0,F

                variable i=i+1

                endw

                RLCF            AARGB1,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                BTFSS           AARGB0,LSB,  BANKED
                bra             UADD138
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                bra             UOK138

UADD138         ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED

UOK138          RLCF            AARGB1,F,    BANKED

                variable i = D'9'

                while i < D'16'

                RLCF            AARGB1,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                BTFSS           AARGB1,LSB,  BANKED
                bra             UADD13#v(i)
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                bra             UOK13#v(i)

UADD13#v(i)     ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED

UOK13#v(i)      RLCF            AARGB1,F,    BANKED

                variable i=i+1

                endw

                RLCF            AARGB2,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                BTFSS           AARGB1,LSB,  BANKED
                bra             UADD1316
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                bra             UOK1316

UADD1316        ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED

UOK1316         RLCF            AARGB2,F,    BANKED


                variable i = D'17'

                while i < D'24'

                RLCF            AARGB2,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                BTFSS           AARGB2,LSB,  BANKED
                bra             UADD13#v(i)
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                bra             UOK13#v(i)

UADD13#v(i)     ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED

UOK13#v(i)      RLCF            AARGB2,F,    BANKED

                variable i=i+1

                endw

                RLCF            AARGB3,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                BTFSS           AARGB2,LSB,  BANKED
                bra             UADD1324
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                bra             UOK1324

UADD1324        ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED

UOK1324         RLCF            AARGB3,F,    BANKED

                variable i = D'25'

                while i < D'32'

                RLCF            AARGB3,W,    BANKED
                RLCF            REMB2, F,    BANKED
                RLCF            REMB1, F,    BANKED
                RLCF            REMB0, F,    BANKED
                MOVFF           BARGB2,WREG
                BTFSS           AARGB3,LSB,  BANKED
                bra             UADD13#v(i)
                SUBWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                SUBWFB          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                SUBWFB          REMB0, F,    BANKED
                bra             UOK13#v(i)

UADD13#v(i)     ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED

UOK13#v(i)      RLCF            AARGB3,F,    BANKED

                variable i=i+1

                endw

                BTFSC           AARGB3,LSB,  BANKED
                bra             UOK13
                MOVFF           BARGB2,WREG
                ADDWF           REMB2, F,    BANKED
                MOVFF           BARGB1,WREG
                ADDWFC          REMB1, F,    BANKED
                MOVFF           BARGB0,WREG
                ADDWFC          REMB0, F,    BANKED
UOK13
                endm

;**********************************************************************************************
;
;       31/23 Bit Unsigned Fixed Point Divide 31/23 -> 31.23
;
;       Input:  31 bit unsigned fixed point dividend in AARGB0, AARGB1,AARGB2,AARGB3
;               23 bit unsigned fixed point divisor in BARGB0, BARGB1, BARGB2
;
;       Use:    CALL    FXD3123U
;
;       Output: 31 bit unsigned fixed point quotient in AARGB0, AARGB1,AARGB2,AARGB3
;               23 bit unsigned fixed point remainder in REMB0, REMB1, REMB2
;
;       Result: AARG, REM  <--  AARG / BARG
;
;       Nominal timing = 500 cycles [~ 50 usec @ 40 MHz fOSC]

FXD3123U
                ; all math variables are banked
                movff   BSR, math_save_BSR
                movlb   BANK_MATH

                CLRF            REMB0, BANKED
                CLRF            REMB1, BANKED
                CLRF            REMB2, BANKED

                UDIV3123

                movff   math_save_BSR, BSR

                RETLW           0x00


;**********************************************************************************************
;       
;       16x16 Bit Unsigned Fixed Point Multiply 16 x 16 -> 32
;
;       Input:  16 bit unsigned fixed point multiplicand in AARGB0, AARGB1
;               16 bit unsigned fixed point multiplier in BARGB0, BARGB1
;
;       Use:    CALL    FXM1616U
;
;       Output: 32 bit unsigned fixed point product in AARGB0, AARGB1, 
;               AARGB2, AARGB3
;
;       Result: AARG  <--  AARG * BARG
;
;       Nominal Timing: ~30 clks

FXM1616U	

        ; all math variables are banked
        movff   BSR, math_save_BSR
        movlb   BANK_MATH

        MOVFF	AARGB1,MATH_TEMP	

		MOVFF	AARGB1,WREG
		MULWF	BARGB1,    BANKED
		MOVFF	PRODH,AARGB2
		MOVFF	PRODL,AARGB3
		
		MOVFF	AARGB0,WREG
		MULWF	BARGB0,    BANKED
		MOVFF	PRODH,AARGB0
		MOVFF	PRODL,AARGB1

		MULWF	BARGB1,    BANKED
		MOVFF	PRODL,WREG
		ADDWF	AARGB2,F,  BANKED
		MOVFF	PRODH,WREG
		ADDWFC	AARGB1,F,  BANKED
		CLRF	WREG
		ADDWFC	AARGB0,F,  BANKED

		MOVFF	MATH_TEMP,WREG
		MULWF	BARGB0,    BANKED
		MOVFF	PRODL,WREG
		ADDWF	AARGB2,F,  BANKED
		MOVFF	PRODH,WREG
		ADDWFC	AARGB1,F,  BANKED
		CLRF	WREG
		ADDWFC	AARGB0,F,  BANKED

        movff   math_save_BSR, BSR
		
		RETLW	0x00
